OGRE: Ogre::TagPoint Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::TagPoint Class Reference

A tagged point on a skeleton, which can be used to attach entities to on specific other entities. More...

`#include <OgreTagPoint.h>`

Inheritance diagram for Ogre::TagPoint:

[legend]
List of all members.

## Public Types

typedef HashMap< String, Node * > | ChildNodeMap
typedef MapIterator< ChildNodeMap > | ChildNodeIterator
typedef ConstMapIterator< ChildNodeMap > | ConstChildNodeIterator
enum | TransformSpace { TS_LOCAL, TS_PARENT, TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...

## Public Member Functions

| TagPoint (unsigned short handle, Skeleton *creator)
virtual | ~TagPoint ()
Entity * | getParentEntity (void) const
MovableObject * | getChildObject (void) const
void | setParentEntity (Entity *pEntity)
void | setChildObject (MovableObject *pObject)
void | setInheritParentEntityOrientation (bool inherit)
| Tells the TagPoint whether it should inherit orientation from it's parent entity.
bool | getInheritParentEntityOrientation (void) const
| Returns true if this TagPoint is affected by orientation applied to the parent entity.
void | setInheritParentEntityScale (bool inherit)
| Tells the TagPoint whether it should inherit scaling factors from it's parent entity.
bool | getInheritParentEntityScale (void) const
| Returns true if this TagPoint is affected by scaling factors applied to the parent entity.
const Matrix4 & | getParentEntityTransform (void) const
| Gets the transform of parent entity.
const Matrix4 & | _getFullLocalTransform (void) const
| Gets the transform of this node just for the skeleton (not entity).
void | needUpdate (bool forceParentUpdate=false)

Remarks:
  This not only tags the node state as being 'dirty', it also requests it's parent to know about it's dirtiness so it will get an update next time.

Parameters:

  | forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

void | updateFromParentImpl (void) const
| Overridden from Node in order to include parent Entity transform.
const LightList & | getLights (void) const

Remarks:
  Directional lights, which have no position, will always be first on this list.

Bone * | createChild (unsigned short handle, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new Bone as a child of this bone.
virtual Node * | createChild (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new Node as a child of this node.
virtual Node * | createChild (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named Node as a child of this node.
unsigned short | getHandle (void) const
| Gets the numeric handle for this bone (unique within the skeleton).
void | setBindingPose (void)
| Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh.
void | reset (void)
| Resets the position and orientation of this Bone to the original binding position.
void | setManuallyControlled (bool manuallyControlled)
| Sets whether or not this bone is manually controlled.
bool | isManuallyControlled () const
| Getter for mManuallyControlled Flag.
void | _getOffsetTransform (Matrix4 &m) const
| Gets the transform which takes bone space to current from the binding pose.
const Vector3 & | _getBindingPoseInverseScale (void) const
| Gets the inverted binding pose scale.
const Vector3 & | _getBindingPoseInversePosition (void) const
| Gets the inverted binding pose position.
const Quaternion & | _getBindingPoseInverseOrientation (void) const
| Gets the inverted binding pose orientation.
const String & | getName (void) const
| Returns the name of the node.
virtual Node * | getParent (void) const
| Gets this node's parent (NULL if this is the root).
virtual const Quaternion & | getOrientation () const
| Returns a quaternion representing the nodes orientation.
virtual void | setOrientation (const Quaternion &q)
| Sets the orientation of this node via a quaternion.
virtual void | setOrientation (Real w, Real x, Real y, Real z)
| Sets the orientation of this node via quaternion parameters.
virtual void | resetOrientation (void)
| Resets the nodes orientation (local axes as world axes, no rotation).
virtual void | setPosition (const Vector3 &pos)
| Sets the position of the node relative to it's parent.
virtual void | setPosition (Real x, Real y, Real z)
| Sets the position of the node relative to it's parent.
virtual const Vector3 & | getPosition (void) const
| Gets the position of the node relative to it's parent.
virtual void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this node.
virtual void | setScale (Real x, Real y, Real z)
| Sets the scaling factor applied to this node.
virtual const Vector3 & | getScale (void) const
| Gets the scaling factor of this node.
virtual void | setInheritOrientation (bool inherit)
| Tells the node whether it should inherit orientation from it's parent node.
virtual bool | getInheritOrientation (void) const
| Returns true if this node is affected by orientation applied to the parent node.
virtual void | setInheritScale (bool inherit)
| Tells the node whether it should inherit scaling factors from it's parent node.
virtual bool | getInheritScale (void) const
| Returns true if this node is affected by scaling factors applied to the parent node.
virtual void | scale (const Vector3 &scale)
| Scales the node, combining it's current scale with the passed in scaling factor.
virtual void | scale (Real x, Real y, Real z)
| Scales the node, combining it's current scale with the passed in scaling factor.
virtual void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the cartesian axes.
virtual void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the cartesian axes.
virtual void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
virtual void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
virtual void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Z-axis.
virtual void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the X-axis.
virtual void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Y-axis.
virtual void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis.
virtual void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an aritrary axis using a Quarternion.
virtual Matrix3 | getLocalAxes (void) const
| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.
virtual void | addChild (Node *child)
| Adds a (precreated) child scene node to this node.
virtual unsigned short | numChildren (void) const
| Reports the number of child nodes under this one.
virtual Node * | getChild (unsigned short index) const
| Gets a pointer to a child node.
virtual Node * | getChild (const String &name) const
| Gets a pointer to a named child node.
virtual ChildNodeIterator | getChildIterator (void)
| Retrieves an iterator for efficiently looping through all children of this node.
virtual ConstChildNodeIterator | getChildIterator (void) const
| Retrieves an iterator for efficiently looping through all children of this node.
virtual Node * | removeChild (unsigned short index)
| Drops the specified child from this node.
virtual Node * | removeChild (Node *child)
| Drops the specified child from this node.
virtual Node * | removeChild (const String &name)
| Drops the named child from this node.
virtual void | removeAllChildren (void)
| Removes all child Nodes attached to this node.
virtual const Quaternion & | _getDerivedOrientation (void) const
| Gets the orientation of the node as derived from all parents.
virtual const Vector3 & | _getDerivedPosition (void) const
| Gets the position of the node as derived from all parents.
virtual const Vector3 & | _getDerivedScale (void) const
| Gets the scaling factor of the node as derived from all parents.
virtual const Matrix4 & | _getFullTransform (void) const
| Gets the full transformation matrix for this node.
virtual void | _update (bool updateChildren, bool parentHasChanged)
| Internal method to update the Node.
virtual void | setListener (Listener *listener)
| Sets a listener for this Node.
virtual Listener * | getListener (void) const
| Gets the current listener for this Node.
const MaterialPtr & | getMaterial (void) const
| Overridden from Renderable.
void | getRenderOperation (RenderOperation &op)
| Overridden from Renderable.
void | getWorldTransforms (Matrix4 *xform) const
| Overridden from Renderable.
const Quaternion & | getWorldOrientation (void) const
const Vector3 & | getWorldPosition (void) const
virtual void | setInitialState (void)
| Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.
virtual void | resetToInitialState (void)
| Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.
virtual const Vector3 & | getInitialPosition (void) const
| Gets the initial position of this node, see setInitialState for more info.
virtual const Quaternion & | getInitialOrientation (void) const
| Gets the initial orientation of this node, see setInitialState for more info.
virtual const Vector3 & | getInitialScale (void) const
| Gets the initial position of this node, see setInitialState for more info.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden, see Renderable.
virtual void | requestUpdate (Node *child, bool forceParentUpdate=false)
| Called by children to notify their parent that they need an update.
virtual void | cancelUpdate (Node *child)
| Called by children to notify their parent that they no longer need an update.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

## Static Public Member Functions

static void | queueNeedUpdate (Node *n)
| Queue a 'needUpdate' call to a node safely.
static void | processQueuedUpdates (void)
| Process queued 'needUpdate' calls.

## Protected Types

typedef std::set< Node * > | ChildUpdateSet
typedef std::vector< Node * > | QueuedUpdates
typedef std::map< size_t, Vector4 > | CustomParameterMap

## Protected Member Functions

Node * | createChildImpl (void)
| See Node.
Node * | createChildImpl (const String &name)
| See Node.
virtual void | setParent (Node *parent)
| Only available internally - notification of parent.
virtual void | _updateFromParent (void) const
| Triggers the node to update it's combined transforms.

## Protected Attributes

unsigned short | mHandle
| The numeric handle of this bone.
bool | mManuallyControlled
| Bones set as manuallyControlled are not reseted in Skeleton::reset().
Skeleton * | mCreator
| Pointer back to creator, for child creation (not smart ptr so child does not preserve parent).
Vector3 | mBindDerivedInverseScale
| The inversed derived scale of the bone in the binding pose.
Quaternion | mBindDerivedInverseOrientation
| The inversed derived orientation of the bone in the binding pose.
Vector3 | mBindDerivedInversePosition
| The inversed derived position of the bone in the binding pose.
Node * | mParent
| Pointer to parent node.
ChildNodeMap | mChildren
| Collection of pointers to direct children; hashmap for efficiency.
ChildUpdateSet | mChildrenToUpdate
| List of children which need updating, used if self is not out of date but children are.
bool | mNeedParentUpdate
| Flag to indicate own transform from parent is out of date.
bool | mNeedChildUpdate
| Flag indicating that all children need to be updated.
bool | mParentNotified
| Flag indicating that parent has been notified about update request.
bool | mQueuedForUpdate
| Flag indicating that the node has been queued for update.
String | mName
| Friendly name of this node, can be automatically generated if you don't care.
Quaternion | mOrientation
| Stores the orientation of the node relative to it's parent.
Vector3 | mPosition
| Stores the position/translation of the node relative to its parent.
Vector3 | mScale
| Stores the scaling factor applied to this node.
bool | mInheritOrientation
| Stores whether this node inherits orientation from it's parent.
bool | mInheritScale
| Stores whether this node inherits scale from it's parent.
MaterialPtr | mpMaterial
| Material pointer should this node be rendered.
Quaternion | mDerivedOrientation
| Cached combined orientation.
Vector3 | mDerivedPosition
| Cached combined position.
Vector3 | mDerivedScale
| Cached combined scale.
Vector3 | mInitialPosition
| The position to use as a base for keyframe animation.
Quaternion | mInitialOrientation
| The orientation to use as a base for keyframe animation.
Vector3 | mInitialScale
| The scale to use as a base for keyframe animation.
Matrix4 | mCachedTransform
| Cached derived transform as a 4x4 matrix.
bool | mCachedTransformOutOfDate
Listener * | mListener
| Node listener - only one allowed (no list) for size & performance reasons.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView

## Static Protected Attributes

static unsigned long | msNextGeneratedNameExt
| Incremented count for next name extension.
static QueuedUpdates | msQueuedUpdates
static const PlaneList | msDummyPlaneList

## Private Attributes

Entity * | mParentEntity
MovableObject * | mChildObject
Matrix4 | mFullLocalTransform
bool | mInheritParentEntityOrientation
bool | mInheritParentEntityScale

## Detailed Description

A tagged point on a skeleton, which can be used to attach entities to on specific other entities.

Remarks:
  A Skeleton, like a Mesh, is shared between Entity objects and simply updated as required when it comes to rendering. However there are times when you want to attach another object to an animated entity, and make sure that attachment follows the parent entity's animation (for example, a character holding a gun in his / her hand). This class simply identifies attachment points on a skeleton which can be used to attach child objects.

  The child objects themselves are not physically attached to this class; as it's name suggests this class just 'tags' the area. The actual child objects are attached to the Entity using the skeleton which has this tag point. Use the Entity::attachMovableObjectToBone method to attach the objects, which creates a new TagPoint on demand.

Definition at line 55 of file OgreTagPoint.h.

## Member Typedef Documentation

typedef MapIterator<ChildNodeMap> Ogre::Node::ChildNodeIterator`[inherited]`

| Definition at line 69 of file OgreNode.h.

typedef HashMap<String, Node*> Ogre::Node::ChildNodeMap`[inherited]`

| Definition at line 68 of file OgreNode.h.

typedef std::set<Node*> Ogre::Node::ChildUpdateSet`[protected, inherited]`

| Definition at line 101 of file OgreNode.h.

typedef ConstMapIterator<ChildNodeMap> Ogre::Node::ConstChildNodeIterator`[inherited]`

| Definition at line 70 of file OgreNode.h.

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

typedef std::vector<Node*> Ogre::Node::QueuedUpdates`[protected, inherited]`

| Definition at line 204 of file OgreNode.h.

## Member Enumeration Documentation

enum Ogre::Node::TransformSpace`[inherited]`

Enumeration denoting the spaces which a transform can be relative to.

Enumeration values:

  TS_LOCAL | Transform is relative to the local space.
  TS_PARENT | Transform is relative to the space of the parent node.
  TS_WORLD | Transform is relative to world space.

Definition at line 59 of file OgreNode.h.

## Constructor & Destructor Documentation

Ogre::TagPoint::TagPoint | ( | unsigned short | handle,
|  | Skeleton * | creator
| ) |

virtual Ogre::TagPoint::~TagPoint | ( |  | ) | `[virtual]`

## Member Function Documentation

const Quaternion& Ogre::Bone::_getBindingPoseInverseOrientation | ( | void |  | ) | const`[inherited]`

| Gets the inverted binding pose orientation. Definition at line 110 of file OgreBone.h.

const Vector3& Ogre::Bone::_getBindingPoseInversePosition | ( | void |  | ) | const`[inherited]`

| Gets the inverted binding pose position. Definition at line 108 of file OgreBone.h.

const Vector3& Ogre::Bone::_getBindingPoseInverseScale | ( | void |  | ) | const`[inherited]`

| Gets the inverted binding pose scale. Definition at line 106 of file OgreBone.h.

virtual const Quaternion& Ogre::Node::_getDerivedOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Gets the orientation of the node as derived from all parents.

virtual const Vector3& Ogre::Node::_getDerivedPosition | ( | void |  | ) | const`[virtual, inherited]`

| Gets the position of the node as derived from all parents.

virtual const Vector3& Ogre::Node::_getDerivedScale | ( | void |  | ) | const`[virtual, inherited]`

| Gets the scaling factor of the node as derived from all parents.

const Matrix4& Ogre::TagPoint::_getFullLocalTransform | ( | void |  | ) | const

| Gets the transform of this node just for the skeleton (not entity).

virtual const Matrix4& Ogre::Node::_getFullTransform | ( | void |  | ) | const`[virtual, inherited]`

Gets the full transformation matrix for this node.

Remarks:
  This method returns the full transformation matrix for this node, including the effect of any parent node transformations, provided they have been updated using the Node::_update method. This should only be called by a SceneManager which knows the derived transforms have been updated before calling this method. Applications using Ogre should just use the relative transforms.

void Ogre::Bone::_getOffsetTransform | ( | Matrix4 & | m | ) | const`[inherited]`

Gets the transform which takes bone space to current from the binding pose.

Remarks:
  Internal use only.

virtual void Ogre::Node::_update | ( | bool | updateChildren,
|  | bool | parentHasChanged
| ) | `[virtual, inherited]`

Internal method to update the Node.

Note:
  Updates this node and any relevant children to incorporate transforms etc. Don't call this yourself unless you are writing a SceneManager implementation.

Parameters:

  | updateChildren | If true, the update cascades down to all children. Specify false if you wish to update children separately, e.g. because of a more selective SceneManager implementation.
  | parentHasChanged | This flag indicates that the parent xform has changed, so the child should retrieve the parent's xform and combine it with its own even if it hasn't changed itself.

Reimplemented in Ogre::SceneNode.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

Definition at line 252 of file OgreRenderable.h.

virtual void Ogre::Node::_updateFromParent | ( | void |  | ) | const`[protected, virtual, inherited]`

Triggers the node to update it's combined transforms.

  This method is called internally by Ogre to ask the node to update it's complete transformation based on it's parents derived transform.

virtual void Ogre::Node::addChild | ( | Node * | child | ) | `[virtual, inherited]`

Adds a (precreated) child scene node to this node.

If it is attached to another node, it must be detached first.

Parameters:

  | child | The Node which is to become a child node of this one

virtual void Ogre::Node::cancelUpdate | ( | Node * | child | ) | `[virtual, inherited]`

| Called by children to notify their parent that they no longer need an update.

virtual Node* Ogre::Node::createChild | ( | const String & | name,
|  | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[virtual, inherited]`

Creates a new named Node as a child of this node.

Remarks:
  This creates a child node with a given name, which allows you to look the node up from the parent which holds this collection of nodes.

Parameters:

  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

virtual Node* Ogre::Node::createChild | ( | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[virtual, inherited]`

Creates an unnamed new Node as a child of this node.

Parameters:

  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

Bone* Ogre::Bone::createChild | ( | unsigned short | handle,
|  | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[inherited]`

Creates a new Bone as a child of this bone.

Remarks:
  This method creates a new bone which will inherit the transforms of this bone, with the handle specified.

Parameters:

  | handle | The numeric handle to give the new bone; must be unique within the Skeleton.
  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

Node* Ogre::Bone::createChildImpl | ( | const String & | name | ) | `[protected, virtual, inherited]`

| See Node. Implements Ogre::Node.

Node* Ogre::Bone::createChildImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| See Node. Implements Ogre::Node.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 187 of file OgreRenderable.h.

virtual Node* Ogre::Node::getChild | ( | const String & | name | ) | const`[virtual, inherited]`

| Gets a pointer to a named child node.

virtual Node* Ogre::Node::getChild | ( | unsigned short | index | ) | const`[virtual, inherited]`

Gets a pointer to a child node.

Remarks:
  There is an alternate getChild method which returns a named child.

virtual ConstChildNodeIterator Ogre::Node::getChildIterator | ( | void |  | ) | const`[virtual, inherited]`

Retrieves an iterator for efficiently looping through all children of this node.

Remarks:
  Using this is faster than repeatedly calling getChild if you want to go through all (or most of) the children of this node. Note that the returned iterator is only valid whilst no children are added or removed from this node. Thus you should not store this returned iterator for later use, nor should you add / remove children whilst iterating through it; store up changes for later. Note that calling methods on returned items in the iterator IS allowed and does not invalidate the iterator.

virtual ChildNodeIterator Ogre::Node::getChildIterator | ( | void |  | ) | `[virtual, inherited]`

Retrieves an iterator for efficiently looping through all children of this node.

Remarks:
  Using this is faster than repeatedly calling getChild if you want to go through all (or most of) the children of this node. Note that the returned iterator is only valid whilst no children are added or removed from this node. Thus you should not store this returned iterator for later use, nor should you add / remove children whilst iterating through it; store up changes for later. Note that calling methods on returned items in the iterator IS allowed and does not invalidate the iterator.

MovableObject* Ogre::TagPoint::getChildObject | ( | void |  | ) | const

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 213 of file OgreRenderable.h.

References OGRE_EXCEPT.

unsigned short Ogre::Bone::getHandle | ( | void |  | ) | const`[inherited]`

| Gets the numeric handle for this bone (unique within the skeleton).

virtual bool Ogre::Node::getInheritOrientation | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this node is affected by orientation applied to the parent node.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  See setInheritOrientation for more info.

bool Ogre::TagPoint::getInheritParentEntityOrientation | ( | void |  | ) | const

| Returns true if this TagPoint is affected by orientation applied to the parent entity.

bool Ogre::TagPoint::getInheritParentEntityScale | ( | void |  | ) | const

| Returns true if this TagPoint is affected by scaling factors applied to the parent entity.

virtual bool Ogre::Node::getInheritScale | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this node is affected by scaling factors applied to the parent node.

Remarks:
  See setInheritScale for more info.

virtual const Quaternion& Ogre::Node::getInitialOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Gets the initial orientation of this node, see setInitialState for more info.

virtual const Vector3& Ogre::Node::getInitialPosition | ( | void |  | ) | const`[virtual, inherited]`

Gets the initial position of this node, see setInitialState for more info.

Remarks:
  Also resets the cumulative animation weight used for blending.

virtual const Vector3& Ogre::Node::getInitialScale | ( | void |  | ) | const`[virtual, inherited]`

| Gets the initial position of this node, see setInitialState for more info.

const LightList& Ogre::TagPoint::getLights | ( | void |  | ) | const`[virtual]`

Remarks:
  Directional lights, which have no position, will always be first on this list.

Reimplemented from Ogre::Node.

virtual Listener* Ogre::Node::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this Node. Definition at line 642 of file OgreNode.h.

virtual Matrix3 Ogre::Node::getLocalAxes | ( | void |  | ) | const`[virtual, inherited]`

| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.

const MaterialPtr& Ogre::Node::getMaterial | ( | void |  | ) | const`[virtual, inherited]`

Overridden from Renderable.

Remarks:
  This is only used if the SceneManager chooses to render the node. This option can be set for SceneNodes at SceneManager::setDisplaySceneNodes, and for entities based on skeletal models using Entity::setDisplayBones()

Implements Ogre::Renderable.

const String& Ogre::Node::getName | ( | void |  | ) | const`[inherited]`

| Returns the name of the node.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 111 of file OgreRenderable.h.

virtual const Quaternion& Ogre::Node::getOrientation | ( |  | ) | const`[virtual, inherited]`

| Returns a quaternion representing the nodes orientation.

virtual Node* Ogre::Node::getParent | ( | void |  | ) | const`[virtual, inherited]`

| Gets this node's parent (NULL if this is the root).

Entity* Ogre::TagPoint::getParentEntity | ( | void |  | ) | const

const Matrix4& Ogre::TagPoint::getParentEntityTransform | ( | void |  | ) | const

| Gets the transform of parent entity.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

virtual const Vector3& Ogre::Node::getPosition | ( | void |  | ) | const`[virtual, inherited]`

| Gets the position of the node relative to it's parent.

void Ogre::Node::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual, inherited]`

Overridden from Renderable.

Remarks:
  This is only used if the SceneManager chooses to render the node. This option can be set for SceneNodes at SceneManager::setDisplaySceneNodes, and for entities based on skeletal models using Entity::setDisplaySkeleton()

Implements Ogre::Renderable.

virtual const Vector3& Ogre::Node::getScale | ( | void |  | ) | const`[virtual, inherited]`

| Gets the scaling factor of this node.

Real Ogre::Node::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual, inherited]`

| Overridden, see Renderable. Implements Ogre::Renderable.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 73 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 161 of file OgreRenderable.h.

const Quaternion& Ogre::Node::getWorldOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Implements Ogre::Renderable.

const Vector3& Ogre::Node::getWorldPosition | ( | void |  | ) | const`[virtual, inherited]`

| Implements Ogre::Renderable.

void Ogre::Node::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual, inherited]`

Overridden from Renderable.

Remarks:
  This is only used if the SceneManager chooses to render the node. This option can be set for SceneNodes at SceneManager::setDisplaySceneNodes, and for entities based on skeletal models using Entity::setDisplaySkeleton()

Implements Ogre::Renderable.

bool Ogre::Bone::isManuallyControlled | ( |  | ) | const`[inherited]`

| Getter for mManuallyControlled Flag.

void Ogre::TagPoint::needUpdate | ( | bool | forceParentUpdate = `false` | ) | `[virtual]`

Remarks:
  This not only tags the node state as being 'dirty', it also requests it's parent to know about it's dirtiness so it will get an update next time.

Parameters:

  | forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

Reimplemented from Ogre::Bone.

virtual unsigned short Ogre::Node::numChildren | ( | void |  | ) | const`[virtual, inherited]`

| Reports the number of child nodes under this one.

virtual void Ogre::Node::pitch | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around the X-axis.

static void Ogre::Node::processQueuedUpdates | ( | void |  | ) | `[static, inherited]`

| Process queued 'needUpdate' calls.

static void Ogre::Node::queueNeedUpdate | ( | Node * | n | ) | `[static, inherited]`

| Queue a 'needUpdate' call to a node safely. You can't call needUpdate() during the scene graph update, e.g. in response to a Node::Listener hook, because the graph is already being updated, and update flag changes cannot be made reliably in that context. Call this method if you need to queue a needUpdate call in this case.

virtual void Ogre::Node::removeAllChildren | ( | void |  | ) | `[virtual, inherited]`

| Removes all child Nodes attached to this node. Does not delete the nodes, just detaches them from this parent, potentially to be reattached elsewhere.

virtual Node* Ogre::Node::removeChild | ( | const String & | name | ) | `[virtual, inherited]`

Drops the named child from this node.

Remarks:
  Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere.

virtual Node* Ogre::Node::removeChild | ( | Node * | child | ) | `[virtual, inherited]`

Drops the specified child from this node.

Remarks:
  Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this node.

virtual Node* Ogre::Node::removeChild | ( | unsigned short | index | ) | `[virtual, inherited]`

Drops the specified child from this node.

Remarks:
  Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this node.

virtual void Ogre::Node::requestUpdate | ( | Node * | child,
|  | bool | forceParentUpdate = `false`
| ) | `[virtual, inherited]`

Called by children to notify their parent that they need an update.

Parameters:

  | forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

void Ogre::Bone::reset | ( | void |  | ) | `[inherited]`

Resets the position and orientation of this Bone to the original binding position.

Remarks:
  Bones are bound to the mesh in a binding pose. They are then modified from this position during animation. This method returns the bone to it's original position and orientation.

virtual void Ogre::Node::resetOrientation | ( | void |  | ) | `[virtual, inherited]`

Resets the nodes orientation (local axes as world axes, no rotation).

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

virtual void Ogre::Node::resetToInitialState | ( | void |  | ) | `[virtual, inherited]`

| Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.

virtual void Ogre::Node::roll | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around the Z-axis.

virtual void Ogre::Node::rotate | ( | const Quaternion & | q,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around an aritrary axis using a Quarternion.

virtual void Ogre::Node::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around an arbitrary axis.

virtual void Ogre::Node::scale | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

Scales the node, combining it's current scale with the passed in scaling factor.

Remarks:
  This method applies an extra scaling factor to the node's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the node's origin.

virtual void Ogre::Node::scale | ( | const Vector3 & | scale | ) | `[virtual, inherited]`

Scales the node, combining it's current scale with the passed in scaling factor.

Remarks:
  This method applies an extra scaling factor to the node's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the node's origin.

void Ogre::Bone::setBindingPose | ( | void |  | ) | `[inherited]`

| Sets the current position / orientation to be the 'binding pose' ie the layout in which bones were originally bound to a mesh.

void Ogre::TagPoint::setChildObject | ( | MovableObject * | pObject | ) |

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 204 of file OgreRenderable.h.

virtual void Ogre::Node::setInheritOrientation | ( | bool | inherit | ) | `[virtual, inherited]`

Tells the node whether it should inherit orientation from it's parent node.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

Parameters:

  | inherit | If true, this node's orientation will be affected by its parent's orientation. If false, it will not be affected.

void Ogre::TagPoint::setInheritParentEntityOrientation | ( | bool | inherit | ) |

Tells the TagPoint whether it should inherit orientation from it's parent entity.

Parameters:

  | inherit | If true, this TagPoint's orientation will be affected by its parent entity's orientation. If false, it will not be affected.

void Ogre::TagPoint::setInheritParentEntityScale | ( | bool | inherit | ) |

Tells the TagPoint whether it should inherit scaling factors from it's parent entity.

Parameters:

  | inherit | If true, this TagPoint's scaling factors will be affected by its parent entity's scaling factors. If false, it will not be affected.

virtual void Ogre::Node::setInheritScale | ( | bool | inherit | ) | `[virtual, inherited]`

Tells the node whether it should inherit scaling factors from it's parent node.

Remarks:
  Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

Parameters:

  | inherit | If true, this node's scale will be affected by its parent's scale. If false, it will not be affected.

virtual void Ogre::Node::setInitialState | ( | void |  | ) | `[virtual, inherited]`

Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.

Remarks:
  You never need to call this method unless you plan to animate this node. If you do plan to animate it, call this method once you've loaded the node with it's base state, ie the state on which all keyframes are based.

  If you never call this method, the initial state is the identity transform, ie do nothing.

virtual void Ogre::Node::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this Node.

Remarks:
  Note for size and performance reasons only one listener per node is allowed.

Definition at line 638 of file OgreNode.h.

void Ogre::Bone::setManuallyControlled | ( | bool | manuallyControlled | ) | `[inherited]`

Sets whether or not this bone is manually controlled.

Remarks:
  Manually controlled bones can be altered by the application at runtime, and their positions will not be reset by the animation routines. Note that you should also make sure that there are no AnimationTrack objects referencing this bone, or if there are, you should disable them using pAnimation->destroyTrack(pBone->getHandle());

virtual void Ogre::Node::setOrientation | ( | Real | w,
|  | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

Sets the orientation of this node via quaternion parameters.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

virtual void Ogre::Node::setOrientation | ( | const Quaternion & | q | ) | `[virtual, inherited]`

Sets the orientation of this node via a quaternion.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

virtual void Ogre::Node::setParent | ( | Node * | parent | ) | `[protected, virtual, inherited]`

| Only available internally - notification of parent. Reimplemented in Ogre::SceneNode.

void Ogre::TagPoint::setParentEntity | ( | Entity * | pEntity | ) |

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 269 of file OgreRenderable.h.

virtual void Ogre::Node::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

| Sets the position of the node relative to it's parent.

virtual void Ogre::Node::setPosition | ( | const Vector3 & | pos | ) | `[virtual, inherited]`

| Sets the position of the node relative to it's parent.

virtual void Ogre::Node::setScale | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

Sets the scaling factor applied to this node.

Remarks:
  Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the node's origin.

virtual void Ogre::Node::setScale | ( | const Vector3 & | scale | ) | `[virtual, inherited]`

Sets the scaling factor applied to this node.

Remarks:
  Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the node's origin.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 147 of file OgreRenderable.h.

virtual void Ogre::Node::translate | ( | const Matrix3 & | axes,
|  | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along arbitrary axes.

Remarks:
  This method translates the node by a vector which is relative to a custom set of axes.

Parameters:

  axes

  A 3x3 Matrix containg 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as

                      1 0 0
                      0 1 0
                      0 0 1

  i.e. the identity matrix.

  | x,y,z | Translation components relative to the axes above.
  | relativeTo | The space which this transform is relative to.

virtual void Ogre::Node::translate | ( | const Matrix3 & | axes,
|  | const Vector3 & | move,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along arbitrary axes.

Remarks:
  This method translates the node by a vector which is relative to a custom set of axes.

Parameters:

  axes

  A 3x3 Matrix containg 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as:

                      1 0 0
                      0 1 0
                      0 0 1

  i.e. the identity matrix.

  | move | Vector relative to the axes above.
  | relativeTo | The space which this transform is relative to.

virtual void Ogre::Node::translate | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along the cartesian axes.

  This method moves the node by the supplied vector along the world cartesian axes, i.e. along world x,y,z

Parameters:

  | x |
  | y |
  | z | Real x, y and z values representing the translation.
  | relativeTo | The space which this transform is relative to.

virtual void Ogre::Node::translate | ( | const Vector3 & | d,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along the cartesian axes.

  This method moves the node by the supplied vector along the world cartesian axes, i.e. along world x,y,z

Parameters:

  | d | Vector with x,y,z values representing the translation.
  | relativeTo | The space which this transform is relative to.

void Ogre::TagPoint::updateFromParentImpl | ( | void |  | ) | const`[virtual]`

| Overridden from Node in order to include parent Entity transform. Reimplemented from Ogre::Node.

virtual void Ogre::Node::yaw | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around the Y-axis. Reimplemented in Ogre::SceneNode.

## Member Data Documentation

Quaternion Ogre::Bone::mBindDerivedInverseOrientation`[protected, inherited]`

| The inversed derived orientation of the bone in the binding pose. Definition at line 134 of file OgreBone.h.

Vector3 Ogre::Bone::mBindDerivedInversePosition`[protected, inherited]`

| The inversed derived position of the bone in the binding pose. Definition at line 136 of file OgreBone.h.

Vector3 Ogre::Bone::mBindDerivedInverseScale`[protected, inherited]`

| The inversed derived scale of the bone in the binding pose. Definition at line 132 of file OgreBone.h.

Matrix4 Ogre::Node::mCachedTransform`[mutable, protected, inherited]`

| Cached derived transform as a 4x4 matrix. Definition at line 198 of file OgreNode.h.

bool Ogre::Node::mCachedTransformOutOfDate`[mutable, protected, inherited]`

| Definition at line 199 of file OgreNode.h.

MovableObject* Ogre::TagPoint::mChildObject`[private]`

| Definition at line 106 of file OgreTagPoint.h.

ChildNodeMap Ogre::Node::mChildren`[protected, inherited]`

| Collection of pointers to direct children; hashmap for efficiency. Definition at line 99 of file OgreNode.h.

ChildUpdateSet Ogre::Node::mChildrenToUpdate`[mutable, protected, inherited]`

| List of children which need updating, used if self is not out of date but children are. Definition at line 103 of file OgreNode.h.

Skeleton* Ogre::Bone::mCreator`[protected, inherited]`

| Pointer back to creator, for child creation (not smart ptr so child does not preserve parent). Definition at line 129 of file OgreBone.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

Quaternion Ogre::Node::mDerivedOrientation`[mutable, protected, inherited]`

Cached combined orientation.

  This member is the orientation derived by combining the local transformations and those of it's parents. This is updated when _updateFromParent is called by the SceneManager or the nodes parent.

Definition at line 147 of file OgreNode.h.

Vector3 Ogre::Node::mDerivedPosition`[mutable, protected, inherited]`

Cached combined position.

  This member is the position derived by combining the local transformations and those of it's parents. This is updated when _updateFromParent is called by the SceneManager or the nodes parent.

Definition at line 156 of file OgreNode.h.

Vector3 Ogre::Node::mDerivedScale`[mutable, protected, inherited]`

Cached combined scale.

  This member is the position derived by combining the local transformations and those of it's parents. This is updated when _updateFromParent is called by the SceneManager or the nodes parent.

Definition at line 165 of file OgreNode.h.

Matrix4 Ogre::TagPoint::mFullLocalTransform`[mutable, private]`

| Definition at line 107 of file OgreTagPoint.h.

unsigned short Ogre::Bone::mHandle`[protected, inherited]`

| The numeric handle of this bone. Definition at line 118 of file OgreBone.h.

bool Ogre::Node::mInheritOrientation`[protected, inherited]`

| Stores whether this node inherits orientation from it's parent. Definition at line 129 of file OgreNode.h.

bool Ogre::TagPoint::mInheritParentEntityOrientation`[private]`

| Definition at line 108 of file OgreTagPoint.h.

bool Ogre::TagPoint::mInheritParentEntityScale`[private]`

| Definition at line 109 of file OgreTagPoint.h.

bool Ogre::Node::mInheritScale`[protected, inherited]`

| Stores whether this node inherits scale from it's parent. Definition at line 132 of file OgreNode.h.

Quaternion Ogre::Node::mInitialOrientation`[protected, inherited]`

| The orientation to use as a base for keyframe animation. Definition at line 193 of file OgreNode.h.

Vector3 Ogre::Node::mInitialPosition`[protected, inherited]`

| The position to use as a base for keyframe animation. Definition at line 191 of file OgreNode.h.

Vector3 Ogre::Node::mInitialScale`[protected, inherited]`

| The scale to use as a base for keyframe animation. Definition at line 195 of file OgreNode.h.

Listener* Ogre::Node::mListener`[protected, inherited]`

| Node listener - only one allowed (no list) for size & performance reasons. Definition at line 202 of file OgreNode.h.

bool Ogre::Bone::mManuallyControlled`[protected, inherited]`

| Bones set as manuallyControlled are not reseted in Skeleton::reset(). Definition at line 121 of file OgreBone.h.

String Ogre::Node::mName`[protected, inherited]`

| Friendly name of this node, can be automatically generated if you don't care. Definition at line 114 of file OgreNode.h.

bool Ogre::Node::mNeedChildUpdate`[mutable, protected, inherited]`

| Flag indicating that all children need to be updated. Definition at line 107 of file OgreNode.h.

bool Ogre::Node::mNeedParentUpdate`[mutable, protected, inherited]`

| Flag to indicate own transform from parent is out of date. Definition at line 105 of file OgreNode.h.

Quaternion Ogre::Node::mOrientation`[protected, inherited]`

| Stores the orientation of the node relative to it's parent. Definition at line 120 of file OgreNode.h.

Node* Ogre::Node::mParent`[protected, inherited]`

| Pointer to parent node. Definition at line 97 of file OgreNode.h.

Entity* Ogre::TagPoint::mParentEntity`[private]`

| Definition at line 105 of file OgreTagPoint.h.

bool Ogre::Node::mParentNotified`[mutable, protected, inherited]`

| Flag indicating that parent has been notified about update request. Definition at line 109 of file OgreNode.h.

MaterialPtr Ogre::Node::mpMaterial`[mutable, protected, inherited]`

| Material pointer should this node be rendered. Definition at line 135 of file OgreNode.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

Vector3 Ogre::Node::mPosition`[protected, inherited]`

| Stores the position/translation of the node relative to its parent. Definition at line 123 of file OgreNode.h.

bool Ogre::Node::mQueuedForUpdate`[mutable, protected, inherited]`

| Flag indicating that the node has been queued for update. Definition at line 111 of file OgreNode.h.

Vector3 Ogre::Node::mScale`[protected, inherited]`

| Stores the scaling factor applied to this node. Definition at line 126 of file OgreNode.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

unsigned long Ogre::Node::msNextGeneratedNameExt`[static, protected, inherited]`

| Incremented count for next name extension. Definition at line 117 of file OgreNode.h.

QueuedUpdates Ogre::Node::msQueuedUpdates`[static, protected, inherited]`

| Definition at line 205 of file OgreNode.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

The documentation for this class was generated from the following file:

- OgreTagPoint.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:19 2008